/* ======================================================================================================== //
// the process of IEC60730 Class B
// ======================================================================================================== */
#pragma section const			l_iec60730_class_b_flash_checkcum		d_iec60730_class_b_flash_checksum_address
static const unsigned short	a_checksum[1] = { d_iec60730_checksum };
#pragma section const

/* ======================================================================================================== //
// ======================================================================================================== */
static void f_iec60730_class_b_startup_flash( void)
{
	{// initial for checksum counter
		r_iec60730.flash.addr = d_ice60730_class_b_flash_start_address;
		r_iec60730.flash.checksum = 0;
	}
	{// start count checksum
		f_iec60730_class_b_runtime_flash();
		while( r_iec60730.flash.addr > d_ice60730_class_b_flash_start_address )
		{
			f_iec60730_class_b_runtime_flash();
			if ( r_iec60730.share.result.bit.flash )
			{
				break;
			}
		}
	}
}

/* ======================================================================================================== //
// ======================================================================================================== */
static void f_iec60730_class_b_runtime_flash( void)
{
	if ( r_iec60730.share.result.bit.flash == 0 )
	{
		r_iec60730.share.addr[0] = ( r_iec60730.flash.addr + 0x100 );	// point of end
		
		while( r_iec60730.flash.addr != r_iec60730.share.addr[0] )
		{
			if ( r_iec60730.flash.addr == d_iec60730_class_b_flash_checksum_address )
			{
				r_iec60730.flash.checksum = (r_iec60730.flash.checksum + (((unsigned short)r_iec60730.flash.addr & 0xff) ^ 0xff));
				r_iec60730.flash.addr++;
				r_iec60730.flash.checksum = (r_iec60730.flash.checksum + (((unsigned short)r_iec60730.flash.addr & 0xff) ^ 0xff));
				r_iec60730.flash.addr++;
			}
			else
			{
				r_iec60730.flash.checksum = (r_iec60730.flash.checksum + (((unsigned short)r_iec60730.flash.addr & 0xff) ^ r_iec60730.flash.addr[0]));
				r_iec60730.flash.addr++;
			}
		}
		
		if ( r_iec60730.flash.addr == 0 )
		{// Finial check
			if ( r_iec60730.flash.checksum != a_checksum[0] )
			{
				r_iec60730.share.result.bit.flash = 1;
			}
			r_iec60730.flash.addr = d_ice60730_class_b_flash_start_address;
			r_iec60730.flash.checksum = 0;
		}
	}
}

/* ======================================================================================================== //
// ======================================================================================================== */
